<?php
/***********************************************************************************/
/* MassCRM客户关系管理系统							   							   */
/* ========================      						 						   */
/* 欢迎使用 MassCRM ,在您开始使用之前,请务必完整阅读本软件附带的全部说明档	  		   */
/***********************************************************************************/
/* Welcome to http://www.massboxes.com & http://masscrm.massboxes.com		   	   */
/***********************************************************************************/
		/*                                                      */
		/*				MassCRM里面用到的基本函数			 		*/
		/*					  作者:阿标							*/
		/*					QQ:190885451						*/
		/*			  Email:biaoest@hotmail.com					*/
		/*			    最后更新: 2005.10.08						*/
		
		
	/************************/
	/*格式化数据,替换<br />  */
	/*用nl2br就转化成了<br />*/
	/************************/
	function format_string($str){
		$str=str_replace("<br />","",$str);
		return $str;
	}
	
	/************************/
	/*增加功能，按当前单据增加*/
	/************************/
	function add_row($table_name,$add_array){
		global $boxesDB;

		$boxesDB->setTableName($table_name);
		for($i=0;$i<count($add_array);$i++){
			$boxesDB->setInsertArray($add_array[$i][0],$add_array[$i][1]);
		}
		$boxes_result=$boxesDB->insertRow();
	}
	
	/************************/
	/*修改功能，按当前单据修改*/
	/************************/
	function update_row($table_name,$update_array,$condition){
		global $boxesDB;

		$boxesDB->setTableName($table_name);
		for($i=0;$i<count($update_array);$i++){
			$boxesDB->setUpdateArray($update_array[$i][0],$update_array[$i][1]);
		}
		$boxesDB->setCondition($condition);
		$boxes_result=$boxesDB->updateRow();
	}
	
	/************************/
	/*删除功能，将原来单据删除*/
	/************************/
	 function delete_row($table_name,$condition){
	 	global $boxesDB;

		$boxesDB->setTableName($table_name);
		$boxesDB->setCondition($condition);
		$boxes_result=$boxesDB->deleteRow();
	 }
	 
	/************************/
	/*		获取时间			*/
	/************************/
	function getmicrotime(){ 
		list($usec, $sec) = explode(" ",microtime()); 
		return ((float)$usec + (float)$sec); 
	}
	
	/************************/
	/*		提示框			*/
	/************************/
	function messagebox($msg){
		echo"<script>alert(\"$msg\");</script>";	
	}
	
	/**************************/
	/*检验函数,和JAVASCRIPT配合*/
	/**************************/
	function checkFieldValidity($field_type){
		if($field_type=="isNumber")//是否正数字
			$check="onChange=\"if(!isNumber(this,''))return false;\"";
		else if($field_type=="isNegative")//是否数字,包括负数
			$check="onChange=\"if(!isNegative(this,''))return false;\"";
		else if($field_type=="isMoney")//是否金钱
			$check="onChange=\"if(!isMoney(this,''))return false;\"";
		else if($field_type=="isDiscount")//是否折扣
			$check="onChange=\"if(!isDiscount(this,''))return false;\"";
		else if($field_type=="isRate")//是否利率
			$check="onChange=\"if(!isRate(this,''))return false;\"";
		else if($field_type=="isLN")//是否字母和数值
			$check="onChange=\"if(!isLN(this,''))return false;\"";
		else
			$check="";
		return $check;
	}
	
	/**************************/
	/*检验函数,和JAVASCRIPT配合*/
	/*  同上,该函数返回后带\"  */
	/**************************/
	function checkFieldValidity2($field_type){
		if($field_type=="isNumber")
			$check="onChange=\\\"if(!isNumber(this,''))return false;\\\"";
		else if($field_type=="isNegative")
			$check="onChange=\\\"if(!isNegative(this,''))return false;\\\"";
		else if($field_type=="isMoney")
			$check="onChange=\\\"if(!isMoney(this,''))return false;\\\"";
		else if($field_type=="isDiscount")
			$check="onChange=\\\"if(!isDiscount(this,''))return false;\\\"";
		else if($field_type=="isRate")
			$check="onChange=\\\"if(!isRate(this,''))return false;\\\"";
		else if($field_type=="isLN")
			$check="onChange=\\\"if(!isLN(this,''))return false;\\\"";
		else
			$check="";
		return $check;
	}
	 
	/**************************/
	/*		只读检查			  */
	/**************************/
	function checkFieldReadOnly($is_readonly){
	 	if($is_readonly){
			$readonly="readonly";	
		}
		else{
			$readonly="";
		}

		return $readonly;
	}
	 
	/**************************/
	/*		显示检查			  */
	/**************************/
	function checkFieldIsDisplay($is_display){
	 	if($is_display){
			$display_type="text";
		}
		else{
			$display_type="hidden";	
		}
		return $display_type;
	}
	 
	/**************************/
	/*		数据空检查		  */
	/**************************/
	function checkFieldCanBeEmpty($field_name,$display_name,$can_be_empty){
	 	if(!$can_be_empty)
			$judgement.="if(!document.form1.".$field_name.".value){alert('错误提示：".$display_name."不能为空！');return false;}";
		return $judgement;
	}
	
	/**************************/
	/*		检查	是否单独成行	  */
	/**************************/
	function checkSingleRow($field_name,$display_width){
	 	$display_width=explode(":",$display_width);
	 	if($display_width[0]>45)
	 		$single_row=true;
	 	
	 	return $single_row;
	}
	 
	/**************************/
	/*		创建自动编号		  */
	/**************************/
	function createInfoID($field_name,$last_number){
	 	$the_next_number=substr($last_number,3,6)+1;
		$the_next_number=$the_next_number%99999999;
		if($the_next_number<10)
			$the_next_number="00000".$the_next_number;
		else if($the_next_number<100)
			$the_next_number="0000".$the_next_number;
		else if($the_next_number<1000)
			$the_next_number="000".$the_next_number;
		else if($the_next_number<10000)
			$the_next_number="00".$the_next_number;
		else if($the_next_number<100000)
			$the_next_number="0".$the_next_number;
			
		if($field_name=="bg_id")	
			$id="WP".$the_next_number;
		elseif($field_name=="bp_id")
			$id="GY".$the_next_number;
		elseif($field_name=="bc_id")
			$id="KH".$the_next_number;
		elseif($field_name=="be_id")
			$id="YG".$the_next_number;	
		elseif($field_name=="blm_id")
			$id="LX".$the_next_number;		
		else
			$id=$the_next_number;	
		return $id;
	}
	 
	/**************************/
	/*	  获取下拉菜单的表名   */
	/**************************/
	function getSelectTable($field_name){
		//一般情况下
	 	$select_table="boxes".substr($field_name,strpos($field_name,"_"));
	 	
	 	//特殊之外的
	 	if($field_name=="customer_name")
			$select_table="boxes_customer";
		elseif($field_name=="blm_name")
			$select_table="boxes_customer_linkman";
		elseif($field_name=="bic_type")
			$select_table="boxes_intercourse_type";
		elseif($field_name=="bic_kind")
			$select_table="boxes_intercourse_kind";	
			
		return $select_table;
	}
	
	/**************************/
	/*	  获取下拉菜单的列表   */
	/**************************/
	function getSelectContent($field_name,$display_width,$selected_value){
		global $smart;
	 	global $conn;
		global $selectMenu;
	 	require_once"../includes/tree.inc.php";
	 	require_once"../includes/BiaoCommon.class.php";
		$boxesDB=new BiaoCommon($conn); 
		
		$select_table=getSelectTable($field_name);
					
		$boxesDB->setTableName("field_display_table");
		$boxesDB->setSelectField("*");
		$sql="where table_name='$select_table'";
		$boxesDB->setCondition($sql);
		$boxes_prefix=$boxesDB->selectResult();
		
		if(count($boxes_prefix)){
			$prefix_row=$boxes_prefix[0];
			
			$boxesDB->setTableName("boxes_module");
			$boxesDB->setSelectField("*");
			$sql="where bm_table='$select_table'";
			$boxesDB->setCondition($sql);
			$boxes_module=$boxesDB->selectResult();
			$select_module_name=$boxes_module[0][bm_name];
			$select_module_num=$boxes_module[0][bm_auto_id];
			
			$selectMenu="";
			$boxesDB->setTableName($select_table);
			$sql="where parent_id=0";
			$boxesDB->setCondition($sql);
			$result=$boxesDB->selectResult();
			
			if(count($result)>0) ShowSelect_name($boxesDB,$result,$layer,$prefix_row[prefix],$selected_value); 
		
			$$field_name="<select name='".$field_name."' onChange=\"addSelect('$field_name','../basic/boxes_basic_common.php','$select_table','$select_module_name','$select_module_num');\">";
			$$field_name.="<option value=''>";
			for($j=$display_width-3;$j>0;$j--)
			{
				$$field_name.="&nbsp;";
			}
			$$field_name.="</option>";
			$$field_name.=$selectMenu;
			$$field_name.="<option value='addselect'>增加……</option>";
			$$field_name.="</select>";
		}
		return 	$$field_name;	
	}
	
	/**************************/
	/*	  获取下拉菜单的列表   */
	/**************************/
	function getOnSelectContent($field_name,$display_name){
		global $smart;
	 	global $conn;
		global $selectMenu;
	 	require_once"../includes/tree.inc.php";
	 	require_once"../includes/BiaoCommon.class.php";
		$boxesDB=new BiaoCommon($conn); 
		
		$select_table=getSelectTable($field_name);
					
		$boxesDB->setTableName("field_display_table");
		$boxesDB->setSelectField("*");
		$sql="where table_name='$select_table'";
		$boxesDB->setCondition($sql);
		$boxes_prefix=$boxesDB->selectResult();
		
		if(count($boxes_prefix)){
			$$field_name=" <img src=\"../images/default/main/select8.gif\" width='15' height='15' alt='选择".$display_name."'";
			if($field_name=="customer_name")
				$$field_name.="onClick=\"selectCustomer('$select_table','选择".$display_name."')\"";
			elseif($field_name=="blm_name")
				$$field_name.="onClick=\"selectLinkMan('$select_table','选择".$display_name."')\"";
			elseif($field_name=="bf_module")
				$$field_name.="onClick=\"selectModule('$select_table','选择".$display_name."')\"";
			elseif($field_name=="bu_role")
				$$field_name.="onClick=\"selectRole('$select_table','选择".$display_name."')\"";	
			else
				$$field_name.="onClick=\"selectSingle('$field_name','$select_table','选择".$display_name."')\"";
			$$field_name.=">";
		}
		return 	$$field_name;	
	}
	
	/**************************/
	/*	  获取性别选项         */
	/**************************/
	function getSexContent($field_name,$display_width,$field_value){
		$$field_name="<input type='radio' name='".$field_name."' value='男' ";
		if($field_value=="男")
			$$field_name.=" checked";
		$$field_name.=" style='BACKGROUND-COLOR:transparent;'> 男 <input type='radio' name='".$field_name."' value='女' ";
		if($field_value=="女")
			$$field_name.=" checked";
		$$field_name.=" style='BACKGROUND-COLOR:transparent;'> 女";
		
		for($j=$display_width-14;$j>0;$j--)
		{
			$$field_name.="&nbsp;";
		}
		
		return 	$$field_name;
	}
	
	/**************************/
	/*	  获取多选项         */
	/**************************/
	function getCheckBoxContent($field_name,$display_width,$field_value){
		$$field_name="<input type='checkbox' name='".$field_name."' value='1'";
		if($field_value)
			$$field_name.=" checked";
		$$field_name.=" style='BACKGROUND-COLOR:transparent;'>";
		for($j=$display_width-2;$j>0;$j--)
		{
			$$field_name.="&nbsp;";
		}
		
		return 	$$field_name;
	}
	
	/**************************/
	/*	  获取时间选择         */
	/**************************/
	function getTimeContent($field_name,$display_width,$field_value){
		$$field_name="<script language=JavaScript>
							arrowtag('$field_name','$field_value');
					  </script>";
		for($j=$display_width-16;$j>0;$j--)
		{
			$$field_name.="&nbsp;";
		}
		
		return 	$$field_name;
	}
	
	/**************************/
	/*	  获取文本区域         */
	/**************************/
	function getTextAreaContent($field_name,$display_array,$field_value){
		
		$display_array=explode(":",$display_array);
		
		if(count($display_array)==2){		
			$$field_name="<textarea name='$field_name' cols='$display_array[0]' rows='$display_array[1]'>$field_value</textarea>";
			
			return 	$$field_name;
		}
	}
	
	/**************************/
	/*	  获取文件选择         */
	/**************************/
	function getFileContent($field_name,$display_width,$field_value){
		if(!$field_value){		
			$$field_name="<input name='$field_name' value='' type='text'><input name='userfile' type='file' size='$display_width' onChange=\"document.all('$field_name').value=this.value.substring(this.value.lastIndexOf('\\\')+1)\" />";
		}
		else{
			
		}
		return 	$$field_name;
	}
	
	/**************************/
	/*	 获取下拉菜单组的表名  */
	/**************************/
	function getGroupTable($field_name){
		//一般情况下
	 	$select_table="boxes".substr($field_name,strpos($field_name,"_"));
	 	$select_table.="_group";
	 	
		//特殊之外的
		
		return $select_table;
	}
	
	
	/**************************/
	/*	 	  检查权限         */
	/**************************/
	function checkRole($table_name,$module_num,$bu_auto_id,$role_name){
	 	global $smart;
	 	global $conn;
	 	require_once"../includes/BiaoCommon.class.php";
	 	
	 	
		$boxesDB=new BiaoCommon($conn); 
		
	 	$boxesDB->setTableName("boxes_user");
		$sql="where bu_auto_id='".$bu_auto_id."'";
		$boxesDB->setCondition($sql);
		$boxes_check=$boxesDB->selectResult();
		
		$bu_role=$boxes_check[0][bu_role];
		
		$boxesDB->setTableName("boxes_role");
		$sql="where br_name='".$bu_role."'";
		$boxesDB->setCondition($sql);
		$boxes_check=$boxesDB->selectResult();
	 	
		$br_value=$boxes_check[0][br_value];
	 	
	 	$boxesDB->setTableName("boxes_function");
		$sql="where (bf_module_num='$module_num' and bf_ename='".$role_name."')";
		$boxesDB->setCondition($sql);
		$boxes_check=$boxesDB->selectResult();
	 	
		$bf_auto_id=$boxes_check[0][bf_auto_id];
		
		if(!$bu_role or !$br_value or ($bf_auto_id and substr($br_value,$bf_auto_id-1,1)!=1)){
			$error="请求失败：你没有模块“".$boxes_check[0][bf_module]."”“".$boxes_check[0][bf_name]."”的权限！";
			echo"<script>alert(\"$error\");</script>";
			$smart->assign(array("error"	=>	$error));
			$smart->display('error.tpl.htm');
			exit;
		}
	
	 	
	}
?>